<template>
	<div>
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<CommonHeader :title="$t('favorites')"></CommonHeader>
		<div class="seccion-header">
			<p class="title">{{$t('myFavorites')}}</p>
			<p class="subtitle">{{$t('easyWay')}}</p>
		</div>
		<div v-for="(restaurant, index) in catalogs" class="restaurantes" :key="index">
			<CardList :restaurant="restaurant">
				<template>
					<button class="delete" @click="showSlide(restaurant)">
						<i class="fa fa-trash"></i>
					</button>
				</template>
			</CardList>
		</div>

		<ModalAction v-if="modal" @close="hideSlide()">
			<template slot="title">
				{{$t('shure?')}}
			</template>
			<template slot="content">
				<div class="content">
					<p>{{$t('deleteFavorites')}}</p>
					<div class="actions">
						<button class="cancelar" @click="hideSlide">{{$t('cancel')}}</button>
						<button class="eliminar" @click="deleteFavorite">{{$t('delete')}}</button>
					</div>
				</div>
				</template>
		</ModalAction>
	</div>
</template>
<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import CardList from '@/components/CardList.vue'
import ModalAction from '@/components/ModalAction.vue'
import axios from 'axios'
import { User } from '@/models/User'
import StorageService from '@/services/StorageService'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import { BusinessType, InfoBusiness, InfoTag } from '@/models/Menu'

@Component({
	components: {
		CommonHeader,
		CardList,
		ModalAction,
		SpinnerHolder
	}
})
export default class Favorites extends Vue {
	loading = false
	user: User = this.$store.state.user
	menus: InfoBusiness [] = []
	modal = false;
	toDelete: InfoBusiness | null = null
	config = {
		headers: {
			Authorization: this.user.authToken,
		}
	}

	async deleteFavorite(){
		try {
			const body = { ordersPlaced: 0, active: false }
			await axios.put(`${process.env.VUE_APP_FAVORITES}/${this.toDelete?.id}`, body ,this.config)
			this.modal = false
			this.$router.push('/profile')
		} catch (err) {
			console.log(err)
			return
		}
	}

	get catalogs(){
		return this.menus
	}

	hideSlide() {
		this.modal = false
	}

	showSlide(toDelete: InfoBusiness){
		this.toDelete = toDelete
		this.modal = true
	}

	async created(){
		this.loading = true
		this.config.headers.Authorization = this.user.authToken
		try {
			const reqFavorites = await axios.get(`${process.env.VUE_APP_FAVORITES}`, this.config)
			const catalogs = reqFavorites.data.filter(data => data.active)
			if (catalogs.length != 0){
				const params = new URLSearchParams()
				catalogs.forEach(cat => { params.append('id', cat.id) });
				const param = { params: params }
				const reqCatalogs = await axios.get(`${process.env.VUE_APP_CATALOG}`, param)
				reqCatalogs.data.forEach(async infBus => {
					const infoBusines: InfoBusiness = { 
					id: infBus.id,
					restaurantId: infBus.restaurantId,
					name: infBus.name,
					description: infBus.description,
					logo: await StorageService.getFile(infBus.logo),
					open: infBus.open,
					directory: {
						businessType: infBus.directory?.businessType ? infBus.directory.businessType : BusinessType.ND,
						infoTag: infBus.open ? infBus.directory?.infoTag : InfoTag.CLOSE,
						businessCategory: infBus.directory?.businessCategory ? infBus.directory?.businessCategory.map(bus => bus.replace('businessTags/', '')) : ['']
					}
				}
					this.menus.push(infoBusines)
				});
			}
		} catch (err) {
			console.log(err)
		}
		this.loading = false
	}

}
</script>
<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}
.seccion-header {
	margin: 0.5em;
}
.title {
	color: #000000;
	font-family: 'Poppins', sans-serif;
	font-style: normal;
	font-weight: 600;
	font-size: 18px;
	line-height: 27px;
}

.subtitle {
	color: #757070;
	font-family: 'Poppins', sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 16px;
	line-height: 24px;
}

.delete {
	padding: 0.5em;
	clip-path: polygon(50% 0%, 100% 24%, 100% 76%, 51% 100%, 0 77%, 0 23%);
	background: #e5ebf7;
	border: 1px solid #e5ebf7;
	.fa-trash {
		font-size: 1.5em;
		color: #646979;
	}
}

.content-next {
	margin: 10px 0;
}

.mostratMas {
	color: #feca38;
	text-align: center;
	border: 1px solid #feca38;
	box-sizing: border-box;
	border-radius: 6px;
	padding: 0.8em;
	width: 90%;
	margin: 1em;
	background: white;
}

.list-content {
	padding: 1em;
}
.content {
	color: #828282;
	font-family: 'Poppins', sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 14px;
	line-height: 21px;
	padding: 0 1em 1em 
}

.actions {
	.cancelar {
		padding: 0.5em;
		width: 45%;
		background: #e0e0e0;
		border: 1px solid #e0e0e0;
		border-radius: 6px;
		color: #828282;
		text-align: center;
		font-family: 'Poppins', sans-serif;
		font-style: normal;
		font-weight: 500;
		font-size: 16px;
		line-height: 24px;
	}
	.eliminar {
		float: right;
		padding: 0.5em;
		width: 45%;
		background: #f4222e;
		border: 1px solid #e0e0e0;
		border-radius: 6px;
		color: white;
		text-align: center;
		font-family: 'Poppins', sans-serif;
		font-style: normal;
		font-weight: 500;
		font-size: 16px;
		line-height: 24px;
	}
}
</style>
